import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


/**
 * ICPC - CTU Open Contest 2021
 * Sample Solution: Screamers
 * 
 * @author Martin Kacer
 */
public class ScreamersMK {
	StringTokenizer st = new StringTokenizer("");
	BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
	boolean hasNextToken() {
		try {
			while (!st.hasMoreTokens()) {
				String line = input.readLine();
				if (line == null) return false;
				st = new StringTokenizer(line);
			}
		} catch (IOException ex) { throw new RuntimeException(ex); }
		return true;
	}
	String nextToken() {
		return (!hasNextToken()) ? null : st.nextToken();
	}
	long nextLong() {
		return Long.parseLong(nextToken());
	}
	public static void main(String[] args) {
		System.out.println(new ScreamersMK().run());
	}
	
	static int gcd(int a, int b) { return (b == 0) ? a : gcd(b, a % b); }
	
	static final long MOD = 1000000007;
	int k;
	
	long[][] mul(long[][] a, long[][] b) {
		long[][] res = new long[k][k];
		for (int w = 0; w < k; ++w)
			for (int i = 0; i < k; ++i)
				for (int j = 0; j < k; ++j)
					res[i][j] = (res[i][j] + (a[i][w] * b[w][j])) % MOD;
		return res;
	}
	
	long run() {
		k = (int) nextLong();
		long n = nextLong() - 1;
		long[][] x = new long[k][k], res = new long[k][k];
		for (int i = 0; i < k; ++i) res[i][i] = 1;
		for (int i = 0; i < k; ++i) for (int j = 0; j <= i; ++j) x[i][j] = x[j][i] = (gcd(i+1,j+1) == 1) ? 1 : 0;
		while (n > 0) {
			if (n % 2 == 1) res = mul(res, x);
			n >>= 1;
			x = mul(x, x);
		}
		long sum = 0;
		for (int i = 0; i < k; ++i) for (int j = 0; j < k; ++j) sum = (sum + res[i][j]) % MOD;
		return sum;
	}
}
